DECLARE SUB Interr (IntNr%, AX%, BX%, CX%, DX%, ES%)

'-- intdelay.bas ----------------------------------------------- >>fst'01<< -
' - Erzeugen eines Delays mit einer Aufloesung von 0,976 Millisekunden
' - mittels Interrupt 15hex, Funktion 86hex.
' - Arbeitet mit der CMOS-Echtzeituhr.
' - Maximale Delayzeit ueber 35 Minuten.
' - Unabhngig von der Rechnergeschwindigkeit.
' - Interruptaufrufe ueber CALL ABSOLUTE; auch fuer QBasic geeignet.
' - Public Domain
'-- V 20011007 ------------------------------ http://home.arcor.de/steini63 -

SCREEN 2    'CGA-Grafik 640x200; auch fuer Palmtops geeignet
LOCATE 2
PRINT "------------------------------------------------------------------------------"
PRINT "Millisekunden-Delay mittels Interrupt 15hex, Funktion 86hex         >>fst'01<<"
PRINT "------------------------------------------------------------------------------"

LOCATE 6, 1
PRINT "Bitte einen Verzoegerungswert pro Pixel in Millisek. eingeben (2-9; 1=10) >";
DO
 MilliSek% = VAL(INKEY$)
LOOP UNTIL MilliSek% > 0
IF MilliSek% = 1 THEN MilliSek% = 10
PRINT MilliSek%

LOCATE 8, 1
PRINT "Schreibe 2 x 640 Pixel mit einem Delay von je"; MilliSek%; "Millisekunden ...";

'Der Verzoegerungswert muss eigentlich in Mikrosekunden uebergeben werden.
'Die Aufloesung betraegt jedoch nur 976 Mikrosekunden. Wird ein Wert > 975
'Mikrosekunden uebergeben, wird 2 * 976 Mikrosekunden gewartet. Fuer sehr
'kleine Verzoegerungen ist deshalb ein Multiplikator unter 976 sinnvoll:
MikroSek& = MilliSek% * 975

'Interrupt 15hex, Funktion 86hex erwartet 32-Bit Verzoegerungswert; das
'16-Bit-HighWord in Register CX, das 16-Bit-LowWord in Register DX.

'MikroSek& in zwei 16-Bit Werte (Word) und vier 8-Bit Werte (Byte) aufloesen:
WordL& = MikroSek& MOD 65536
WordH& = MikroSek& \ 65536
B0% = WordL& MOD 256
B1% = WordL& \ 256
B2% = WordH& MOD 256
B3% = WordH& \ 256

'- Delay ueber speziellen Maschinencode -------------------------------------

LOCATE 12, 1
PRINT "Delay mittels speziellem Maschinencode (Aufloesung 976 Mikrosekunden):"

'Maschinencode im String Int1586$:
'  MOV AH,86h    ;Funktionsnummer 86hex nach AH
'  MOV DX,n1n0   ;HighWord nach DX: n1=Wert von B1%, n0=Wert von B0%
'  MOV CX,n3n2   ;LowWord  nach CX: n3=Wert von B3%, n2=Wert von B2%
'  INT 15h       ;Interrupt 15hex aufrufen
'  RETF          ;zurueck zu Basic
Int1586$ = "" + CHR$(B0%) + CHR$(B1%) + "" + CHR$(B2%) + CHR$(B3%) + ""

DEF SEG = VARSEG(Int1586$)  'Speicher-Segment von Int1586$ festlegen
Offset% = SADD(Int1586$)    'Speicher-Offset vom Int1586$ speichern

T1 = TIMER                  'Startzeit festhalten
FOR i% = 0 TO 639           '640 Schleifen
 PSET (i%, 100)             'Pixel zeichnen
 CALL ABSOLUTE(Offset%)     'Delay erzeugen (Maschinencode ausfuehren)
 'Fehler "Unterprogramm nicht definiert" ? -> QuickBasic mit /L starten!
NEXT
PRINT : PRINT TIMER - T1; " Sekunden"         'Zeitverbrauch anzeigen

'- Delay mittels SUB Interr -------------------------------------------------

LOCATE 17, 1
PRINT "Delay mittels universellem Interruptaufruf (Aufloesung 976 Mikrosekunden):"

IntNr% = &H15               'Interrupt 15hex
AX% = &H8600                'Funktion 86hex
AXk% = AX%                  'Kopie von AX%
BX% = 0                     'BX ist ohne Bedeutung
CX% = WordH&                'CX ist niederwertiger Wert (in Mikrosekunden)
DX% = WordL&                'DX ist hoeherwertiger Wert (in Mikrosekunden)
ES% = 0                     'ES ist ohne Bedeutung

T1 = TIMER                  'Startzeit festhalten
FOR i% = 0 TO 639           '640 Schleifen
 PSET (i%, 140)             'Pixel zeichnen
 AX% = AXk%                 'AX% wird von der SUB Interr veraendert!
 CALL Interr(IntNr%, AX%, BX%, CX%, DX%, ES%) 'Interrupt Routine starten
NEXT
PRINT : PRINT TIMER - T1; " Sekunden"         'Zeitverbrauch anzeigen
PRINT : PRINT "Taste ..."

'- ENDE ---------------------------------------------------------------------
SLEEP           'Tastendruck abwarten
SCREEN 0        'zurueck zum Textmodus
END             'E n d e

SUB Interr (IntNr%, AX%, BX%, CX%, DX%, ES%)
'Interr ruft einen beliebigen Interrupt auf und liefert einen
'Rueckgabewerte aus den 5 Registern.
'Parameter: Interrupt-Nummer, Register-AX, -BX, -CX, -DX, -ES

'Der Maschinencode befindet sich im String MC$
'erzeugt mit absolute.bas aus dem Assembler Quelltext interr.asm
'DOWNLOAD: http://home.arcor.de/steini63/pbeisp.htm
MC$ = "UVvvEv	MvvvvEv	MvvFM^E^]PS"
'                                       ^hier muss die Interrupt-Nr. hin

'Speicher-Segment und -Offset von ASM$ festlegen:
DEF SEG = VARSEG(MC$)
Offset% = SADD(MC$)

'Interruptnummer in den Maschinencode einfuegen (Stelle im String -1):
POKE Offset% + 33, IntNr%

'Maschinencode ausfuehren:
CALL ABSOLUTE(AX%, BX%, CX%, DX%, ES%, Offset%)
'Fehler "Unterprogramm nicht definiert" ? -> QuickBasic mit /L starten!

'Segment wiederherstellen:
DEF SEG

END SUB

