DECLARE FUNCTION EineMS& ()
DECLARE SUB LoopDelay (ST&)

'-- lopdelay.bas ----------------------------------------------- >>fst'01<< -
' - Erzeugen eines Delays mit einer DO-LOOP-Schleife.
' - Um verschiedene Rechnergeschwindigkeit auszugleichen, wird mit der
'   FUNCTION EineMS$ die Schleifenanzahl in einer Systemtimer-Periode
'   (55 Millisekunden) gemessen und durch 55 geteilt.
' - Die gemessene Schleifenzahl wird an die SUB LoopDelay uebergeben,
'   die den Delay erzeugt.
' - Public Domain
'-- V 20010920 ------------------------------ http://home.arcor.de/steini63 -

SCREEN 2    'CGA-Grafik 640x200; auch fuer Palmtops geeignet
LOCATE 2
PRINT "------------------------------------------------------------------------------"
PRINT "Delay mittels geschwindigkeitsangepasster DO-LOOP-Schleife          >>fst'01<<"
PRINT "------------------------------------------------------------------------------"

LOCATE 6, 1
PRINT "Bitte einen Verzoegerungswert pro Pixel in Millisek. eingeben (2-9; 1=10) >";
DO
 Millisek% = VAL(INKEY$)
LOOP UNTIL Millisek% > 0
IF Millisek% = 1 THEN Millisek% = 10
PRINT Millisek%

LOCATE 8, 1
PRINT "Schreibe 2 x 640 Pixel mit einem Delay von je"; Millisek%; "Millisekunden ...";


'- Delay ueber DO-LOOP-Schleife ---------------------------------------------

MS& = EineMS&                 'DO-LOOP-Schleifen pro eine Millisek. messen
Schleifen& = MS& * Millisek%  'mit Benutzereingabe multiplizieren

LOCATE 12, 1
PRINT "Schleifenzahl pro Millisekunde :"; MS&


LOCATE 16, 1
PRINT "Delay mittels DO-LOOP-Schleife"

T1 = TIMER                    'Startzeit festhalten
FOR i% = 0 TO 639             '640 Schleifen
 PSET (i%, 131)               'Pixel zeichnen
 CALL LoopDelay(Schleifen&)   'Delay erzeugen
NEXT
PRINT : PRINT TIMER - T1; " Sekunden"         'Zeitverbrauch anzeigen

'- ENDE ---------------------------------------------------------------------
SLEEP           'Tastendruck abwarten
SCREEN 0        'zurueck zum Textmodus
END             'E n d e

FUNCTION EineMS&
'Misst die Anzahl von DO-LOOP-Schleifen innerhalb einer Systemtimer-Periode
'(ca. 55 Millisekunden) und gibt die Anzahl fuer eine Millisekunde zurueck.

DEF SEG = 0                       'BIOS-Datensegment setzen
ST% = PEEK(&H46C)                 'niederwertigen Systemtimer-Wert lesen
DO: LOOP WHILE ST% = PEEK(&H46C)  'Zaehlersprung abwarten
ST& = PEEK(&H46C)                 'neuen Zaehlerwert lesen

'Messschleife zur Bestimming der Schleifenzahl in 55 Millisekunden. Long-
'Interger Variablen, wo sie auch in der SUB LoopDelay verwendet werden:
DO
 Z& = Z& + 1                      'Schleifenzaehler
 T& = PEEK(&H46C)                 'Zaehlerwert lesen
LOOP UNTIL ST& <> T&              'beenden bei Zaehlersprung

EineMS& = Z& \ 55                 'Schleifenzahl fuer eine Millisekunde

END FUNCTION

SUB LoopDelay (SZ&)
'erzeugt einen Schleifendelay. Um verschiedene Rechnergeschwindigkeiten
'zu kompensieren, kann mit der FUNCTION EineMS& die Anzahl der Schleifen
'fuer eine Millisekunde bestimmt werden.

DO                    'Delayschleife starten
 Z& = Z& + 1          'Schleifenzaehler
 T& = PEEK(&H46C)     'Dummybefehl, damit identisch zur Schleife in EineMS&
LOOP UNTIL Z& >= SZ&  'Ende, wenn uebergebene Schleifenzahl erreicht

END SUB

